/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   dist_item.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_DIST_ITEM_H
#define UHDM_DIST_ITEM_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class dist_item : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: dist_item();
    virtual ~dist_item() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    dist_item* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    int VpiDistType() const { return vpiDistType_; }

    bool VpiDistType(int data) { vpiDistType_ = data; return true;}

    const expr* Weight() const { return weight_; }

    bool Weight(expr* data) { weight_ = data; return true;}

    const any* Value_range() const { return value_range_; }

    bool Value_range(any* data) {if (!expr_range_groupGroupCompliant(data)) return false; value_range_ = data; return true;}

    unsigned int VpiType() const final { return vpiDistItem; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmdist_item; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    int vpiDistType_ = 0;

    expr* weight_ = nullptr;

    any* value_range_ = nullptr;

  };

  
  class dist_itemFactory {
  friend Serializer;
  public:
  dist_item* Make() {
    dist_item* obj = new dist_item();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<dist_item*> objects_;
  };
  
  
  class VectorOfdist_itemFactory {
  friend Serializer;
  public:
  std::vector<dist_item*>* Make() {
    std::vector<dist_item*>* obj = new std::vector<dist_item*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<dist_item*>*> objects_;
  };

};

#endif
