/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   distribution.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_DISTRIBUTION_H
#define UHDM_DISTRIBUTION_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class distribution : public constraint_expr {
  public:
    // Implicit constructor used to initialize all members,
    // comment: distribution();
    virtual ~distribution() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    distribution* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    bool VpiSoft() const { return vpiSoft_; }

    bool VpiSoft(bool data) { vpiSoft_ = data; return true;}

    const expr* Expr() const { return expr_; }

    bool Expr(expr* data) { expr_ = data; return true;}

    VectorOfdist_item* Dist_items() const { return dist_items_; }

    bool Dist_items(VectorOfdist_item* data) { dist_items_ = data; return true;}

    unsigned int VpiType() const final { return vpiDistribution; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmdistribution; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    bool vpiSoft_ = 0;

    expr* expr_ = nullptr;

    VectorOfdist_item* dist_items_ = nullptr;

  };

  
  class distributionFactory {
  friend Serializer;
  public:
  distribution* Make() {
    distribution* obj = new distribution();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<distribution*> objects_;
  };
  
  
  class VectorOfdistributionFactory {
  friend Serializer;
  public:
  std::vector<distribution*>* Make() {
    std::vector<distribution*>* obj = new std::vector<distribution*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<distribution*>*> objects_;
  };

};

#endif
