/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   immediate_assert.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_IMMEDIATE_ASSERT_H
#define UHDM_IMMEDIATE_ASSERT_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class immediate_assert : public atomic_stmt {
  public:
    // Implicit constructor used to initialize all members,
    // comment: immediate_assert();
    virtual ~immediate_assert() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    immediate_assert* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    int VpiIsDeferred() const { return vpiIsDeferred_; }

    bool VpiIsDeferred(int data) { vpiIsDeferred_ = data; return true;}

    int VpiIsFinal() const { return vpiIsFinal_; }

    bool VpiIsFinal(int data) { vpiIsFinal_ = data; return true;}

    int VpiStartLine() const { return vpiStartLine_; }

    bool VpiStartLine(int data) { vpiStartLine_ = data; return true;}

    int VpiColumn() const { return vpiColumn_; }

    bool VpiColumn(int data) { vpiColumn_ = data; return true;}

    int VpiEndLine() const { return vpiEndLine_; }

    bool VpiEndLine(int data) { vpiEndLine_ = data; return true;}

    int VpiEndColumn() const { return vpiEndColumn_; }

    bool VpiEndColumn(int data) { vpiEndColumn_ = data; return true;}

    const expr* Expr() const { return expr_; }

    bool Expr(expr* data) { expr_ = data; return true;}

    const clocking_block* Clocking_block() const { return clocking_block_; }

    bool Clocking_block(clocking_block* data) { clocking_block_ = data; return true;}

    const any* Stmt() const { return stmt_; }

    bool Stmt(any* data) {if (!stmtGroupCompliant(data)) return false; stmt_ = data; return true;}

    const any* Else_stmt() const { return else_stmt_; }

    bool Else_stmt(any* data) {if (!stmtGroupCompliant(data)) return false; else_stmt_ = data; return true;}

    unsigned int VpiType() const final { return vpiImmediateAssert; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmimmediate_assert; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    int vpiIsDeferred_ = 0;

    int vpiIsFinal_ = 0;

    int vpiStartLine_ = 0;

    int vpiColumn_ = 0;

    int vpiEndLine_ = 0;

    int vpiEndColumn_ = 0;

    expr* expr_ = nullptr;

    clocking_block* clocking_block_ = nullptr;

    any* stmt_ = nullptr;

    any* else_stmt_ = nullptr;

  };

  
  class immediate_assertFactory {
  friend Serializer;
  public:
  immediate_assert* Make() {
    immediate_assert* obj = new immediate_assert();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<immediate_assert*> objects_;
  };
  
  
  class VectorOfimmediate_assertFactory {
  friend Serializer;
  public:
  std::vector<immediate_assert*>* Make() {
    std::vector<immediate_assert*>* obj = new std::vector<immediate_assert*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<immediate_assert*>*> objects_;
  };

};

#endif
