/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   range.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_RANGE_H
#define UHDM_RANGE_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class range : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: range();
    virtual ~range() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual bool VpiFile(const std::string& data) final;

    virtual const std::string& VpiFile() const final;

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    range* DeepClone(Serializer* serializer, ElaboratorListener* elab_listener, BaseClass* parent) const override;

    int VpiSize() const { return vpiSize_; }

    bool VpiSize(int data) { vpiSize_ = data; return true;}

    const expr* Left_expr() const { return left_expr_; }

    bool Left_expr(expr* data) { left_expr_ = data; return true;}

    const expr* Right_expr() const { return right_expr_; }

    bool Right_expr(expr* data) { right_expr_ = data; return true;}

    unsigned int VpiType() const final { return vpiRange; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmrange; }   
  private:
    
    BaseClass* vpiParent_ = nullptr;

    unsigned int uhdmParentType_ = 0;

    SymbolFactory::ID vpiFile_ = 0;

    unsigned int uhdmId_ = 0;

    int vpiSize_ = 0;

    expr* left_expr_ = nullptr;

    expr* right_expr_ = nullptr;

  };

  
  class rangeFactory {
  friend Serializer;
  public:
  range* Make() {
    range* obj = new range();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<range*> objects_;
  };
  
  
  class VectorOfrangeFactory {
  friend Serializer;
  public:
  std::vector<range*>* Make() {
    std::vector<range*>* obj = new std::vector<range*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<range*>*> objects_;
  };

};

#endif
